src/main/java/com/algaworks/encodev/model/Destino.java
package com.algaworks.encodev.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name = "destino")
public class Destino implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	private Long codigo;
	
	private String nome;
	
	private Integer distancia;

	public Long getCodigo() {
		return codigo;
	}

	public void setCodigo(Long codigo) {
		this.codigo = codigo;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public Integer getDistancia() {
		return distancia;
	}

	public void setDistancia(Integer distancia) {
		this.distancia = distancia;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((codigo == null) ? 0 : codigo.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Destino other = (Destino) obj;
		if (codigo == null) {
			if (other.codigo != null)
				return false;
		} else if (!codigo.equals(other.codigo))
			return false;
		return true;
	}

}

src/main/java/com/algaworks/encodev/model/Entrega.java
package com.algaworks.encodev.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.NotEmpty;

@Entity
@Table(name = "entrega")
public class Entrega implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	private Long codigo;

	@NotNull
	@ManyToOne
	@JoinColumn(name = "codigo_destino")
	private Destino destino;

	@NotNull
	@Enumerated(EnumType.STRING)
	@Column(name = "tipo_entrega", nullable = false, length = 20)
	private TipoEntrega tipoEntrega;

	@NotNull
	@Enumerated(EnumType.STRING)
	@Column(name = "tipo_notificacao", nullable = false, length = 20)
	private TipoNotificacao tipoNotificacao;

	@NotEmpty
	private String destinatario;
	
	@Column(name = "dias_previstos")
	private Integer diasPrevistos;

	public Long getCodigo() {
		return codigo;
	}

	public void setCodigo(Long codigo) {
		this.codigo = codigo;
	}

	public Destino getDestino() {
		return destino;
	}

	public void setDestino(Destino destino) {
		this.destino = destino;
	}

	public TipoEntrega getTipoEntrega() {
		return tipoEntrega;
	}

	public void setTipoEntrega(TipoEntrega tipoEntrega) {
		this.tipoEntrega = tipoEntrega;
	}

	public TipoNotificacao getTipoNotificacao() {
		return tipoNotificacao;
	}

	public void setTipoNotificacao(TipoNotificacao tipoNotificacao) {
		this.tipoNotificacao = tipoNotificacao;
	}

	public String getDestinatario() {
		return destinatario;
	}

	public void setDestinatario(String destinatario) {
		this.destinatario = destinatario;
	}
	
	public Integer getDiasPrevistos() {
		return diasPrevistos;
	}

	public void setDiasPrevistos(Integer diasPrevistos) {
		this.diasPrevistos = diasPrevistos;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((codigo == null) ? 0 : codigo.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Entrega other = (Entrega) obj;
		if (codigo == null) {
			if (other.codigo != null)
				return false;
		} else if (!codigo.equals(other.codigo))
			return false;
		return true;
	}

}

src/main/java/com/algaworks/encodev/model/TipoEntrega.java
package com.algaworks.encodev.model;

import javax.enterprise.inject.Instance;

import com.algaworks.encodev.service.entrega.CalculadoraEntrega;
import com.algaworks.encodev.service.entrega.util.CalculadoraQualifier;

public enum TipoEntrega {

	NORMAL("Normal") {
		@Override
		public CalculadoraEntrega obterCalculadora(Instance<CalculadoraEntrega> calculadoras) {
			return calculadoras.select(new CalculadoraQualifier(NORMAL)).get();
		}
	},
	EXPRESSA("Expressa") {
		@Override
		public CalculadoraEntrega obterCalculadora(Instance<CalculadoraEntrega> calculadoras) {
			return calculadoras.select(new CalculadoraQualifier(EXPRESSA)).get();
		}
	};
	
	private String descricao;
	
	TipoEntrega(String descricao) {
		this.descricao = descricao;
	}
	
	public String getDescricao() {
		return descricao;
	}
	
	public abstract CalculadoraEntrega obterCalculadora(Instance<CalculadoraEntrega> calculadoras);
	
}

src/main/java/com/algaworks/encodev/model/TipoNotificacao.java
package com.algaworks.encodev.model;

import javax.enterprise.inject.Instance;

import com.algaworks.encodev.service.notificacao.NotificadorCliente;
import com.algaworks.encodev.service.notificacao.util.NotificadorQualifier;

public enum TipoNotificacao {

	EMAIL("e-mail") {
		@Override
		public NotificadorCliente obterNotificador(Instance<NotificadorCliente> notificadores) {
			return notificadores.select(new NotificadorQualifier(EMAIL)).get();
		}
	},
	SMS("SMS") {
		@Override
		public NotificadorCliente obterNotificador(Instance<NotificadorCliente> notificadores) {
			return notificadores.select(new NotificadorQualifier(SMS)).get();
		}
	};
	
	private String descricao;
	
	private TipoNotificacao(String descricao) {
		this.descricao = descricao;
	}
	
	public String getDescricao() {
		return descricao;
	}
	
	public abstract NotificadorCliente obterNotificador(Instance<NotificadorCliente> notificadores);
}

src/main/java/com/algaworks/encodev/controller/CadastroEntregaBean.java
package com.algaworks.encodev.controller;

import java.io.Serializable;
import java.util.List;

import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;

import com.algaworks.encodev.model.Destino;
import com.algaworks.encodev.model.Entrega;
import com.algaworks.encodev.model.TipoEntrega;
import com.algaworks.encodev.model.TipoNotificacao;
import com.algaworks.encodev.repository.Destinos;
import com.algaworks.encodev.service.GestaoEntregasService;
import com.algaworks.encodev.service.notificacao.NotificacaoException;
import com.algaworks.encodev.util.jsf.FacesMessages;

@Named
@ViewScoped
public class CadastroEntregaBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private Destinos destinos;

	private List<Destino> todosDestinos;
	
	@Inject
	private FacesMessages facesMessages;

	private Entrega entrega;
	
	@Inject
	private GestaoEntregasService gestaoEntregasService;
	
	public CadastroEntregaBean() {
		entrega = new Entrega();
	}
	
	public void inicializar() {
		todosDestinos = destinos.todos();
	}

	public void salvar() {
		try {
			entrega = gestaoEntregasService.registrar(entrega);
			
			facesMessages.info("Encomenda registrada com sucesso. Serão " + entrega.getDiasPrevistos() + " dia(s).");
			entrega = new Entrega();
		} catch (NotificacaoException e) {
			facesMessages.error(e.getMessage());
		}
	}

	public List<Destino> getTodosDestinos() {
		return todosDestinos;
	}

	public TipoEntrega[] getTiposEntregas() {
		return TipoEntrega.values();
	}

	public TipoNotificacao[] getTiposNotificacoes() {
		return TipoNotificacao.values();
	}

	public Entrega getEntrega() {
		return entrega;
	}
	
}

src/main/webapp/CadastroEntrega.xhtml
<!DOCTYPE html>
<ui:composition template="/WEB-INF/templates/Layout.xhtml"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:p="http://primefaces.org/ui">

    <ui:define name="corpo">
    	<f:metadata>
			<f:viewAction action="#{cadastroEntregaBean.inicializar}" />
		</f:metadata>
    	<h1>Cadastro de entrega</h1>
    	
    	<h:form id="frm">
    		<p:messages id="messages" autoUpdate="true" />
    		
	    	<h:panelGrid columns="2" style="margin-top: 20px" id="painel">
	    		<p:outputLabel value="Destino" for="destino"/>
	    		<p:selectOneMenu id="destino" value="#{cadastroEntregaBean.entrega.destino}" style="width: 170px">
	    			<f:selectItem itemLabel="Selecione o destino" />
	    			<f:selectItems value="#{cadastroEntregaBean.todosDestinos}" var="destino" 
						itemLabel="#{destino.nome}" itemValue="#{destino}"/>
	    		</p:selectOneMenu>
	    		
	    		<p:outputLabel value="Tipo de Entrega" for="tipoEntrega"/>
	    		<p:selectOneMenu id="tipoEntrega" value="#{cadastroEntregaBean.entrega.tipoEntrega}" style="width: 170px">
	    			<f:selectItems value="#{cadastroEntregaBean.tiposEntregas}" var="tipoEntrega" 
						itemLabel="#{tipoEntrega.descricao}" itemValue="#{tipoEntrega}"/>
	    		</p:selectOneMenu>
	    		
	    		<p:outputLabel value="Tipo de Notificação" for="tipoNotificacao"/>
	    		<p:selectOneMenu id="tipoNotificacao" value="#{cadastroEntregaBean.entrega.tipoNotificacao}" style="width: 170px">
	    			<f:selectItems value="#{cadastroEntregaBean.tiposNotificacoes}" var="tipoNotificacao" 
						itemLabel="#{tipoNotificacao.descricao}" itemValue="#{tipoNotificacao}"/>
	    		</p:selectOneMenu>
	    		
	    		<p:outputLabel value="Destinatário" for="destinatario"/>
	    		<p:inputText id="destinatario" value="#{cadastroEntregaBean.entrega.destinatario}" size="40"/>
	    		
	    		<p:outputLabel/>
	    		<p:commandButton value="Registrar" action="#{cadastroEntregaBean.salvar}" update="@form"/>
	    	</h:panelGrid>
    	</h:form>
    </ui:define>
</ui:composition>

src/main/webapp/WEB-INF/templates/Layout.xhtml
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:p="http://primefaces.org/ui">
<h:head>
	<meta charset="UTF-8"/>
	<title>Encodev - Transportadora</title>
	
	<h:outputStylesheet library="algaworks" name="estilo.css" />
</h:head>
<h:body>
	<p:ajaxStatus styleClass="ajax-status">
		<f:facet name="start">
			<h:graphicImage library="algaworks" name="carregando.gif" />
		</f:facet>
		<f:facet name="complete">
			<h:outputText value="" />
		</f:facet>
	</p:ajaxStatus>


	<header>
		<h:graphicImage library="algaworks" name="logo.png" />
	</header>

	<h:form>
		<p:menubar style="margin-top: -20px; margin-bottom: 20px">
			<p:submenu label="Cadastros">
				<p:menuitem value="Entrega" outcome="/CadastroEntrega" />
				<p:menuitem value="Destinos" />
			</p:submenu>
			<p:submenu label="Minha conta">
				<p:menuitem value="Sair" />
			</p:submenu>
		</p:menubar>
		
		<p:confirmDialog global="true">
	       	<p:commandButton value="Não" type="button" styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
			<p:commandButton value="Sim" type="button" styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
		</p:confirmDialog>
	</h:form>

	<div id="conteudo">
		<ui:insert name="corpo"></ui:insert>
	</div>
	
	<footer>
		Palestra "Aprenda a aplicar polimorfismo no seu projeto" ministrada no Encodev - Encontro Nacional de Desenvolvimento de Software
	</footer>

</h:body>
</html>